package test;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.InetSocketAddress;
import java.net.Socket;

public class CommunicationHandler extends Thread {
	public Socket cSocket;
	PrintWriter out;
	BufferedReader in;
	boolean run = true;
	public String buffer = "";

	CommunicationHandler() {
	}
	
	public String getBuffer(){
		String tmp = buffer;
		buffer = "";
		return tmp;
	}

	public boolean connectToSock(String ip, int port) {
		try {
			this.cSocket = new Socket();
			this.cSocket.connect(new InetSocketAddress(ip, port));
			out = new PrintWriter(cSocket.getOutputStream(), true);
			in = new BufferedReader(new InputStreamReader(cSocket.getInputStream()));
		} catch (IOException e) {
			System.err.println("Connection attempt failed.");
			return false;
		}
		System.out.println("Connection attempt successfull!");
		this.start();
		return true;
	}

	public void handleCommand(String cmd) {
		if (cmd.startsWith("E ")) {
			cmd = cmd.substring(cmd.indexOf(' ') + 1);
			System.out.println("Error: " + cmd);
		} else {
			System.out.println(cmd);
		}
	}

	private String read() {
		try {
			return in.readLine();
		} catch (IOException e) {
			System.err.println(e.getMessage());
			endThread(true);
			return "";
		}
	}

	public void run() {
		while (run) {
			String msg = read();
			if (msg != null) {
				if (buffer.equals("")) {
					buffer += msg;
				} else {
					buffer += "\n" + msg;
				}

			}
		}
	}

	public void send(String msg) {
		out.println(msg);
		out.flush();
	}

	public void sendB(String msg) {
		out.print(msg + "\n");
		out.flush();
	}

	public void endThread(boolean sendMsg) {
		run = false;

		if (sendMsg) {
			send("X");
		}

		try {
			in.close();
			out.close();
			cSocket.close();

			System.out.println("Connection successfully closed.");
		} catch (IOException e) {
			System.err.println(e.getMessage());
			e.printStackTrace();
		}
	}
}